﻿using System.Diagnostics;
using System.IO;
using System.Text;

namespace YaTools.Yaml
{
    public class DebugWriter : TextWriter
    {
        public override Encoding Encoding
        {
            get { return Encoding.Unicode; }
        }

        public override void Write(char value)
        {
            Debug.Write(value);
        }

        public override void Write(string value)
        {
            Debug.Write(value);
        }

        public override void WriteLine()
        {
            Debug.WriteLine(string.Empty);
        }

        public override void WriteLine(string value)
        {
            Debug.WriteLine(value);
        }
    }
}