﻿// Enums.cs
//
// Copyright 2008 by Burt Harris
// Licensed under the Microsoft Public License (Ms-PL)
// See: http://www.codeplex.com/yaml/license
//

namespace YaTools.Yaml
{
    public enum Token
    {
        BeginningOfStream = -3,
        Outdent = -2,
        EndOfStream = -1,
        Directive,
        DirectivesEnd,
        DocumentEnd,
        BlockMappingBegin,
        BlockSeqBegin, // '-' first at a level
        TextContent,
        ImplicitKey,
        BlockKeyIndicator, // '?' in block context
        FlowKeyIndicator, // '?' in flow context
        ValueIndicator, // ':' 
        BlockSeqNext, // '-' following the first at a level
        Comma, // ','
        OpenBrace,
        CloseBrace,
        OpenBracket,
        CloseBracket,
        Anchor,
        Alias,
        At,
        Backtick,
        Tag,
        Literal,
        Folded,
        Escape,
        EscapeWhiteSpace,
        InconsistentIndent,
        Unexpected,

        // Tokens NoOp and beyond may be skipped over in test code
        NoOp,
        Comment,
        EmptyLine,
        IndentSpaces,
        LeadingWhiteSpace, // Special token generated only in folded sink
        PlainScalar,
        PlainEnd,
        DoubleQuote,
        SingleQuote,
        EscapedLineBreak,
        Newline
    };
}